# coding: utf-8

"""
    Arduino IoT Cloud API

    Provides a set of endpoints to manage Arduino IoT Cloud **Devices**, **Things**, **Properties** and **Timeseries**. This API can be called just with any HTTP Client, or using one of these clients:  * [Javascript NPM package](https://www.npmjs.com/package/@arduino/arduino-iot-client)  * [Python PYPI Package](https://pypi.org/project/arduino-iot-client/)  * [Golang Module](https://github.com/arduino/iot-client-go)

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ArduinoDevicev2propertyvalueValueStatistics(BaseModel):
    """
    ArduinoDevicev2propertyvalueValueStatistics
    """ # noqa: E501
    adr: Optional[Union[StrictFloat, StrictInt]] = None
    channel: Optional[Union[StrictFloat, StrictInt]] = None
    duplicate: Optional[Union[StrictFloat, StrictInt]] = None
    freq: Optional[Union[StrictFloat, StrictInt]] = None
    mod_bw: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="modBW")
    rssi: Optional[Union[StrictFloat, StrictInt]] = None
    seqno: Optional[Union[StrictFloat, StrictInt]] = None
    sf: Optional[Union[StrictFloat, StrictInt]] = None
    snr: Optional[Union[StrictFloat, StrictInt]] = None
    time: Optional[Union[StrictFloat, StrictInt]] = None
    __properties: ClassVar[List[str]] = ["adr", "channel", "duplicate", "freq", "modBW", "rssi", "seqno", "sf", "snr", "time"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ArduinoDevicev2propertyvalueValueStatistics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ArduinoDevicev2propertyvalueValueStatistics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "adr": obj.get("adr"),
            "channel": obj.get("channel"),
            "duplicate": obj.get("duplicate"),
            "freq": obj.get("freq"),
            "modBW": obj.get("modBW"),
            "rssi": obj.get("rssi"),
            "seqno": obj.get("seqno"),
            "sf": obj.get("sf"),
            "snr": obj.get("snr"),
            "time": obj.get("time")
        })
        return _obj


