# coding: utf-8

"""
    Arduino IoT Cloud API

    Provides a set of endpoints to manage Arduino IoT Cloud **Devices**, **Things**, **Properties** and **Timeseries**. This API can be called just with any HTTP Client, or using one of these clients:  * [Javascript NPM package](https://www.npmjs.com/package/@arduino/arduino-iot-client)  * [Python PYPI Package](https://pypi.org/project/arduino-iot-client/)  * [Golang Module](https://github.com/arduino/iot-client-go)

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ArduinoSeriesSampledResponse(BaseModel):
    """
    ArduinoSeriesSampledResponse media type (default view)
    """ # noqa: E501
    count_values: StrictInt = Field(description="Total number of values in the array 'values'")
    from_date: datetime = Field(description="From date")
    interval: StrictInt = Field(description="Resolution in seconds")
    message: Optional[StrictStr] = Field(default='', description="If the response is different than 'ok'")
    property_id: Optional[StrictStr] = Field(default=None, description="Property id")
    property_name: Optional[StrictStr] = Field(default=None, description="Property name")
    property_type: Optional[StrictStr] = Field(default=None, description="Property type")
    query: StrictStr = Field(description="Query of for the data")
    resp_version: StrictInt = Field(description="Response version")
    series_limit: Optional[StrictInt] = Field(default=None, description="Maximum number of values returned after data aggregation, if any")
    status: StrictStr = Field(description="Status of the response")
    thing_id: Optional[StrictStr] = Field(default=None, description="Thing id")
    times: List[datetime] = Field(description="Timestamp in RFC3339")
    to_date: datetime = Field(description="To date")
    values: List[Any] = Field(description="Values in Float")
    __properties: ClassVar[List[str]] = ["count_values", "from_date", "interval", "message", "property_id", "property_name", "property_type", "query", "resp_version", "series_limit", "status", "thing_id", "times", "to_date", "values"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ArduinoSeriesSampledResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ArduinoSeriesSampledResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "count_values": obj.get("count_values"),
            "from_date": obj.get("from_date"),
            "interval": obj.get("interval"),
            "message": obj.get("message") if obj.get("message") is not None else '',
            "property_id": obj.get("property_id"),
            "property_name": obj.get("property_name"),
            "property_type": obj.get("property_type"),
            "query": obj.get("query"),
            "resp_version": obj.get("resp_version"),
            "series_limit": obj.get("series_limit"),
            "status": obj.get("status"),
            "thing_id": obj.get("thing_id"),
            "times": obj.get("times"),
            "to_date": obj.get("to_date"),
            "values": obj.get("values")
        })
        return _obj


