# coding: utf-8

"""
    Arduino IoT Cloud API

    Provides a set of endpoints to manage Arduino IoT Cloud **Devices**, **Things**, **Properties** and **Timeseries**. This API can be called just with any HTTP Client, or using one of these clients:  * [Javascript NPM package](https://www.npmjs.com/package/@arduino/arduino-iot-client)  * [Python PYPI Package](https://pypi.org/project/arduino-iot-client/)  * [Golang Module](https://github.com/arduino/iot-client-go)

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BatchQueryRequestMediaV1(BaseModel):
    """
    BatchQueryRequestMediaV1
    """ # noqa: E501
    aggregation: Optional[StrictStr] = Field(default=None, description="Aggregation statistic function. For numeric values, AVG statistic is used by default. PCT_X compute the Xth approximate percentile (e.g. PCT_95 is the 95th approximate percentile). For boolean, BOOL_OR statistic is used as default.")
    var_from: datetime = Field(description="From timestamp", alias="from")
    interval: Optional[StrictInt] = Field(default=None, description="Resolution in seconds (max allowed: 86400)")
    q: StrictStr = Field(description="Data selection query (e.g. property.2a99729d-2556-4220-a139-023348a1e6b5 or thing.95717675-4786-4ffc-afcc-799777755391)")
    series_limit: Optional[StrictInt] = Field(default=None, description="Maximum number of values returned after data aggregation, if any (default: 300, limit: 1000 - 10000 in case of thing query)")
    to: datetime = Field(description="To timestamp")
    __properties: ClassVar[List[str]] = ["aggregation", "from", "interval", "q", "series_limit", "to"]

    @field_validator('aggregation')
    def aggregation_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['AVG', 'MIN', 'MAX', 'SUM', 'COUNT', 'PCT_99', 'PCT_95', 'PCT_90', 'PCT_75', 'PCT_50', 'PCT_15', 'PCT_5', 'BOOL_OR', 'BOOL_AND']):
            raise ValueError("must be one of enum values ('AVG', 'MIN', 'MAX', 'SUM', 'COUNT', 'PCT_99', 'PCT_95', 'PCT_90', 'PCT_75', 'PCT_50', 'PCT_15', 'PCT_5', 'BOOL_OR', 'BOOL_AND')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BatchQueryRequestMediaV1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BatchQueryRequestMediaV1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "aggregation": obj.get("aggregation"),
            "from": obj.get("from"),
            "interval": obj.get("interval"),
            "q": obj.get("q"),
            "series_limit": obj.get("series_limit"),
            "to": obj.get("to")
        })
        return _obj


