# coding: utf-8

"""
    Arduino IoT Cloud API

    Provides a set of endpoints to manage Arduino IoT Cloud **Devices**, **Things**, **Properties** and **Timeseries**. This API can be called just with any HTTP Client, or using one of these clients:  * [Javascript NPM package](https://www.npmjs.com/package/@arduino/arduino-iot-client)  * [Python PYPI Package](https://pypi.org/project/arduino-iot-client/)  * [Golang Module](https://github.com/arduino/iot-client-go)

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class BatchQuerySampledRequestMediaV1(BaseModel):
    """
    BatchQuerySampledRequestMediaV1
    """ # noqa: E501
    var_from: Optional[datetime] = Field(default=None, description="From timestamp (default: now UTC - 24h)", alias="from")
    interval: Optional[Annotated[int, Field(le=86400, strict=True, ge=60)]] = Field(default=300, description="Resolution in seconds (allowed min:60, max:86400)")
    q: StrictStr = Field(description="Data selection query (e.g. property.2a99729d-2556-4220-a139-023348a1e6b5)")
    series_limit: Optional[StrictInt] = Field(default=None, description="Maximum number of values returned after data aggregation, if any (default: 300, limit: 1000)")
    to: Optional[datetime] = Field(default=None, description="To timestamp (default: now UTC)")
    __properties: ClassVar[List[str]] = ["from", "interval", "q", "series_limit", "to"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BatchQuerySampledRequestMediaV1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BatchQuerySampledRequestMediaV1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "from": obj.get("from"),
            "interval": obj.get("interval") if obj.get("interval") is not None else 300,
            "q": obj.get("q"),
            "series_limit": obj.get("series_limit"),
            "to": obj.get("to")
        })
        return _obj


